<template>
  <div class="main-container fr-p-2w">
    <AtomLoader
      v-if="pending"
      class="fr-mx-auto"
    />
    <AtomAlert
      v-else-if="error"
      :alert-type="AlertType.Error"
      message="Les statistiques de la répartion des données mobilité n'ont pas pu être chargées."
    />
    <template v-else-if="mobilityCounts">
      <h2 class="fr-h5">Données mobilité</h2>
      <StatsList
        v-if="mobilityCounts.length"
        :total-count="beneficiaryCount"
        :stats="mobilityCounts"
        stats-bar
      />
      <p v-else>
        Commencez à
        <NuxtLink
          :to="Routes.BeneficiariesAdd"
          target="_self"
          >créer des fiches de bénéficiaires</NuxtLink
        >
        pour voir apparaître les statistiques de la répartition des données
        mobilité.
      </p>
    </template>
  </div>
</template>

<script setup>
  import { MOBILITY_MODE_OPTIONS } from '~/utils/constants/beneficiary'
  import { AlertType } from '~~/utils/constants/alert'
  import { errorResponseMessage } from '~~/utils/errorResponse'
  import { labelOrUnprovided } from '~~/utils/stats'
  import { Routes } from '~/utils/routing/routes'

  const { $getItems } = useNuxtApp()

  const props = defineProps({
    beneficiaryCount: {
      type: Number,
      required: true
    },
    filters: {
      type: Object,
      required: true
    }
  })

  const {
    data: mobilityCounts,
    pending,
    error,
    refresh
  } = useLazyAsyncData('mobilityCounts', loadMobilityCounts, {
    server: false
  })

  watch(() => props.filters, refresh)

  async function loadMobilityCounts() {
    const res = await $getItems('beneficiary', {
      groupBy: 'mobility',
      aggregate: { countDistinct: 'id' },
      filter: props.filters
    })

    if (res.status === 200) {
      const mobilityResCounts = res.data.data.map(mobility => ({
        key: mobility.mobility,
        label: labelOrUnprovided(mobility.mobility, MOBILITY_MODE_OPTIONS),
        count: parseInt(mobility.countDistinct.id)
      }))
      mobilityResCounts.sort((a, b) => b.count - a.count)
      return mobilityResCounts
    }
    throw new Error(errorResponseMessage(res))
  }
</script>
